<!DOCTYPE html>
<html lang="en"
      xmlns:th="http://www.thymeleaf.org"
      xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
      layout:decorate="~{layout3}">
<head>
    <meta charset="UTF-8">
    <title>Approval </title>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <style>
        .container {
            position: relative;
            min-height: 100vh;
        }

        .loader-overlay {
            display: none;
            position: fixed;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            background: rgba(255, 255, 255, 0.8);
            z-index: 9999;
        }

        .loader-container {
            position: absolute;
            top: 50%;
            left: 50%;
            transform: translate(-50%, -50%);
            text-align: center;
        }

        .loader {
            width: 48px;
            height: 48px;
            border: 5px solid #ddd;
            border-radius: 50%;
            border-top-color: #2196F3;
            animation: spin 1s linear infinite;
            margin: 0 auto;
        }

        .loader-text {
            margin-top: 10px;
            font-family: Arial, sans-serif;
            color: #666;
        }

        @keyframes spin {
            0% { transform: rotate(0deg); }
            100% { transform: rotate(360deg); }
        }
    </style>
</head>
<body>

<main
        layout:fragment="main"
        class="container-xxl bd-gutter mt-3 my-md-4"
>
    <!--    <div th:include="sidebar/sidebar_approval::sidebar_approval" th:remove="tag">-->
    <!--        sidebar-->
    <!--    </div>-->
    <main class="bd-main-xxl">
        <div class="row">
            <div class="col-md-12">
                <div class="h4 pb-2 mb-4 text-dark border-bottom border-dark">
                    <span><i class="fa fa-book" style="color: #9B7536"></i> Dokumen</span>
                </div>
            </div>
        </div>

        <div class="row mb-3">
            <div class="col-md-12">
                <div class="loader-overlay">
                    <div class="loader-container">
                        <div class="loader"></div>
                        <div class="loader-text">Loading...</div>
                    </div>
                </div>
                <div class="card bg-transparent p-3">
                    <div class="card-body">
                        <div class="mb-3 ps-3 bg-transparent">
                            <div class="row">
                                <form method="get">
                                    <div class="col-md-8 mb-3 p-3 bg-transparent">
                                        <div class="mb-3 row">
                                            <label for="selectsatu" class="col-sm-4 col-form-label">Academic Year</label>
                                            <div class="col-sm-8">
                                                <select class="form-select bg-transparent" name="tahun" id="selectsatu">
                                                    <option selected disabled value="">Select data</option>
                                                    <option th:each="datas : ${tahun}"
                                                            th:text="${datas.namaTahunAkademik}"
                                                            th:data-mulai="${datas.tanggalMulai}"
                                                            th:data-selesai="${datas.tanggalSelesai}"
                                                            th:value="${datas.id}">sdasd</option>
                                                </select>
                                                <input type="hidden" name="mulai" id="tglMulai">
                                                <input type="hidden" name="selesai" id="tglSelesai">
                                            </div>
                                        </div>
                                        <div class="mb-3 row">
                                            <label for="selectdua" class="col-sm-4 bg-transparent col-form-label">Lecturer</label>
                                            <div class="col-sm-8">
                                                <select class="form-select bg-transparent" name="dosen" id="selectdua">
                                                    <option selected disabled value="">Select data</option>
                                                </select>
                                            </div>
                                        </div>
                                        <div class="row button-download" style="display: none">
                                            <div class="col-md-4"></div>
                                            <div class="col-md-4 p-3">
                                                <button type="submit" class="btn btn-primary pull-left" id="simpan">Process</button>
                                            </div>
                                        </div>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="row" th:if="${dosen != null}">
            <div class="card bg-transparent p-3">
                <div class="card-header">
                    <div class="row align-item-center">
                        <div class="col-md-6 col-sm-6">
                            <div th:text="${'Dosen : ' + dosen.dosen}"></div>
                        </div>
                        <div class="col-md-6 col-sm-6 text-end">
                            <a class="btn btn-primary" th:href="@{/document/download(tahun=${idTahun}, dosen=${idDosen}, no=${code}, mulai=${mulai}, selesai=${selesai})}"><i class="fa fa-download"></i> Download Surat Tugas Mengajar</a>
                        </div>
                    </div>
                </div>
                <div class="card-body">
                    <div class="col-md-12 table-responsive">
                        <table class="table table-hover table-striped small">
                            <thead>
                            <tr>
                                <th scope="col" class="text-end align-middle text-center">No</th>
                                <th scope="col" class="align-middle text-center">Jenis</th>
                                <th scope="col" class="align-middle text-center">Matakuliah</th>
                                <th scope="col" class="align-middle text-center">Kelas</th>
                                <th scope="col" class="align-middle text-center">Mulai</th>
                                <th scope="col" class="align-middle text-center">Selesai</th>
                            </tr>
                            </thead>
                            <tbody class="align-middle">
                            <tr th:each="matkul,row : ${dosen.jadwal}">
                                <td class="text-end border-0" th:text="${row.index + 1}">1.</td>
                                <td class="text-center border-0" th:text="${matkul.jenis}">BEASISWA</td>
                                <td class="text-center border-0" th:text="${matkul.matakuliah}">BEASISWA</td>
                                <td class="text-center border-0" th:text="${matkul.kelas}">BEASISWA</td>
                                <td class="text-center border-0" th:text="${matkul.mulai}">BEASISWA</td>
                                <td class="text-center border-0" th:text="${matkul.selesai}">BEASISWA</td>
                            </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
            <br />
        </div>

    </main>
</main>

<section layout:fragment="footer">

</section>
</body>
</html>
<script>
    $(document).ready(function (){

        $('#selectsatu').on('select2:selecting', function (e){
            var data = e.params.args.data;
            var selectedOption = $(data.element);

            var mulai = selectedOption.data('mulai');
            var selesai = selectedOption.data('selesai');

            $('#tglMulai').val(mulai);
            $('#tglSelesai').val(selesai);
        });

        $('#selectsatu').change(function (){
            const tahun = $(this).val();
            const $dosen = $('#selectdua');
            const $buttton = $('.button-download');

            if (!tahun) {
                $dosen.hide();
                $buttton.hide();
                return;
            }

            $('.loader-overlay').fadeIn();

            // Ajax request
            $.ajax({
                url: `api/get-dosen/${tahun}`,
                method: 'GET',
                success: function (data){
                    $dosen.html('<option selected disabled value="">Select data</option>');

                    data.forEach(function (item){
                        $dosen.append(
                            $('<option></option>').val(item.id).text(item.dosen)
                        );
                    });
                    $dosen.trigger('change');

                    $buttton.hide();
                },
                error: function (xhr, status, error){
                    $('#hasil').html('<p style="color: red;">An error occurred while loading data</p>');
                    console.error('Error:', error)
                },
                complete: function (){
                    $('.loader-overlay').fadeOut();
                }
            });
        });

        $('#selectdua').change(function (){
            const dosen = $(this).val();
            const $buttton = $('.button-download');

            if (!dosen){
                $buttton.hide();
                return;
            }

            $buttton.show();
        })
    });
</script>